<?php 
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
	$reportName = 'FBT Statutory Report';
	$reportVariables=array();
	
	$reportVariables[] = '$tooltipSection = "report_fbtstatutory";';
	$reportVariables[] = 'echo form_FBTYear_select("fbtYear", "fbtYear", "", "FBT Year", $tooltipSection, 7)."<br/>";';

	$reportVariables[] = 'echo form_checkbox("useemployeefilter", "useemployeefilter", false, $label="Use Employees",$tooltipSection);';
	$reportVariables[] = 'echo form_employee_multiselect("employeeK[]", "employeeK", 0, true, 10,"Employee(s):",$tooltipSection);';

	//$reportVariables[] = 'echo form_checkbox("usecarfilter", "usecarfilter", false, $label="Use Vehicles",$tooltipSection);';
	$reportVariables[] = 'echo form_vehicle_select("vehicleK[]", "vehicleK", 0, true, 10,"Select specific vehicles to report on:<br /><br .>(* = Archived vehicle):",$tooltipSection);';
	$reportVariables[] = 'echo form_site_select("siteFK", "siteFK", "", "Location",$tooltipSection);';
	$reportVariables[] = 'echo form_checkbox("usearchived", "usearchived", false, $label="Include Archived Vehicles",$tooltipSection);';
	

	$useEmployeeFilter = (isset($p->useemployeefilter))?true:false;
	$useCarFilter = (isset($p->usecarfilter))?true:false;
	
	$vehicleIds = isset($p->vehicleK)?$p->vehicleK:'';	
	$useArchived = (isset($p->usearchived) && $p->usearchived==1)?true:false;
	$employeeIds = isset($p->employeeK)?$p->employeeK:'';
	$fbtYear = isset($p->fbtYear)?$p->fbtYear:'';
	$years = explode('-', $fbtYear);
	
	$startYear = $years[0];
	$endYear = $years[0]+1;
	$location = isset($p->siteFK)?$p->siteFK:''; 
	
	//Uncomment to debug
	//$startYear=2006;
	//$endYear = 2007;
		
	
	$startDateString = $startYear.'-04-01';
	$endDateString = $endYear.'-03-31';
	$startDate = strtotime($startDateString);
	$endDate = strtotime($endDateString);	
	
	//load any cars that have an FBT entry
	$sql = "SELECT 
											vehicle.*,
											reg.number as regNum, 
											manuf.name as manName, 
											model.modelname,
											f.*,
											emp.*, tblSite.name as 'Location'
											
									FROM 
											tblVehicle vehicle 
													INNER JOIN 
											tblModel model ON vehicle.modelFK = model.modelK 
													INNER JOIN 
											tblManufacturer manuf ON model.manufacturerFK = manuf.manufacturerK 
													INNER JOIN 
											tblRego reg ON vehicle.vehicleK = reg.vehicleFK
													INNER JOIN
											tblFBT f ON vehicle.vehicleK = f.vehicleFK
													INNER JOIN
											tblEmployee emp ON f.employeeFK = emp.employeeK	INNER JOIN tblSite on siteK = vehicle.siteFK															
											";	
	
	$sql .= '  WHERE f.date_commenced>="'.$startDateString.'" AND f.date_commenced<="'.$endDateString.'"';
	
	if($useCarFilter){
		$sql .= ' AND (vehicle.vehicleK IN ('.implode($vehicleIds,',').'))';
	}	
	
	if($useEmployeeFilter){
		$sql .= ' AND (f.employeeFK IN ('.implode($employeeIds,',').'))';
	}	
	
	if(!$useArchived && !$vehicleIds){
		$sql  .= ' AND (archived = 0) ';
	}
	
	if($location>0){
		$sql .= ' AND (vehicle.siteFK = '. $location .') ';
	}
	
	$sql .= ' GROUP BY vehicle.vehicleK, f.employeeFK';
	echo $sql;
	
	
	if(!$res = dbQuery($sql)){
		die('SQL Error: '.dbError());
	}else{
			$vehicle['ID'] = 'Vehicle ID';			
			$vehicle['employee'] = 'Employee';
			$vehicle['registration'] = 'Reg';
			$vehicle['Location'] = 'Location';
			$vehicle['MakeModel'] = 'Make & Model';

			$vehicle['A'] = 'Base Value';
			$vehicle['B'] = 'Statutory %';
			$vehicle['C'] = 'Private Days';
			$vehicle['D'] = 'Days in FBT Year';  
			$vehicle['grossTaxableValue'] = 'Gross Taxable Value';
			$vehicle['E'] = 'Employee Contributions'; 
			$vehicle['F'] = 'Number of KMs Travelled';
			$vehicle['G'] = 'Number of Days in Period';
			$vehicle['H'] = 'Days in FBT Year';
			$vehicle['J'] = 'Statutory %';
			$vehicle['anuallised'] = 'Anualised KMs';
			$reportArray[] = $vehicle;
					
		
				
	
		$statPercentages = array(array('min'=>0,'max'=>14999,'percentage'=>26), array('min'=>15000,'max'=>24999,'percentage'=>20), array('min'=>25000,'max'=>40000,'percentage'=>11), array('min'=>40001,'max'=>-1,'percentage'=>7));
		while($temp = dbFetchAssoc($res)){
			$vehicle['ID'] = $temp['vehicleK'];			
			$vehicle['employee'] = '(ID #: '.$temp['employeeFK'].') '.$temp['firstname'].' '.$temp['lastname'];
			$vehicle['registration'] = $temp['regNum'];//$temp[''];
			$vehicle['Location'] = $temp['Location'];
			$vehicle['MakeModel'] = $temp['manName'].' '.$temp['modelname'];


			$vehicle['F'] = getKmsByVehicleAndEmployee($vehicle['ID'], $temp['employeeFK']); 				// Number of KMs travelled							[SUM(tblReimbursements.totalKms)]
			$vehicle['G'] = $temp['private_days']; 							// Number of days in FBT Period 				[tblFBT.private_days]
			$vehicle['H'] = isLeapYear($startYear)?366:365; 	// Number of days in the FBT Year
			$vehicle['anuallised'] = ($vehicle['F'] * $vehicle['H'])/$vehicle['G'];
			for($i=0;$i<count($statPercentages);$i++){
				if($vehicle['anuallised']>=$statPercentages[$i]['min']){
					if($statPercentages[$i]['max']==-1){
						$vehicle['J'] = $statPercentages[$i]['percentage']; 																				// statutory perecentage			
					}else{
						if($vehicle['anuallised']<=$statPercentages[$i]['max']){
							$vehicle['J'] = $statPercentages[$i]['percentage']; 																				// statutory perecentage
						}
					}
				}
			}
			
					
		
			$vehicle['A'] = $temp['fbt_value']; 			// Vehicles base Value; 									[tblFBT.fbt_value]
			$vehicle['B'] = $vehicle['J']; 													// statutory perecentage
			$vehicle['C'] = $temp['private_days']; 	// days available for private use; 				[tblFBT.private_days]
			$vehicle['D'] = isLeapYear($startYear)?366:365; 	// days in the FBT year, default 365  
			$vehicle['grossTaxableValue'] = ($vehicle['A'] * ($vehicle['B']/100) * $vehicle['C'])/$vehicle['D'];
			$vehicle['E'] = 0; 													// Employee Contributions
			
			
			$reportArray[] = $vehicle;
		}	
	
			
	}
	
	$customreport = true;	
	
	function isLeapYear($year) {
 		return ($year % 4 == 0 && 
  		($year % 100 != 0 || $year % 400 == 0));
	}
	
	
	function getKmsByVehicleAndEmployee($vehicleID, $employeeID){
		$sql = 'SELECT SUM(totalkms) as totalKs FROM tblReimbursements WHERE vehicleFK="'.$vehicleID.'" AND employeeFK="'.$employeeID.'"';
		//echo $sql;
		//echo $sql.'<br/>';
		$return=0;
		if(!$res = dbQuery($sql)){
			$errors[] = 'SQL Error:'.dbError($sql);
		}else{
			if(dbNumRows($res)>0){
				$item= dbFetchAssoc($res);
				if(!is_numeric($item['totalKs'])){
					$return = 0;
				}else{
					$return = $item['totalKs'];
				}
			}
		}
		return $return;
	}
	

?>