<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/

$reportName = 'KMs By Vehicle';
$reportVariables[] = '$tooltipSection = "report_kmsbyvehicle";';
$reportVariables[] = 'echo form_checkbox("usedatefilter", "usedatefilter", false, $label="Use Dates",$tooltipSection);';
$reportVariables[] = 'echo form_date_select("startDate", "startDate", "", "Start Date:",$tooltipSection);';
$reportVariables[] = 'echo form_date_select("endDate", "endDate", "", "End Date:",$tooltipSection);';
//$reportVariables[] = 'echo form_checkbox("usecarfilter", "usecarfilter", false, $label="Use Vehicles",$tooltipSection);';

$reportVariables[] = 'echo form_vehicle_select("vehicleK[]", "vehicleK", 0, true, 10,"Select specific vehicles to report on:<br /><br .>(* = Archived vehicle):",$tooltipSection);';
$reportVariables[] = 'echo form_site_select("siteFK", "siteFK", "", "Location",$tooltipSection);';
$reportVariables[] = 'echo form_checkbox("usearchived", "usearchived", false, $label="Include Archived Vehicles",$tooltipSection);';
$conditions = array();



if($p) {
	$useDateFilter = (isset($p->usedatefilter) && $p->usedatefilter==1)?true:false;
	$useCarFilter = (isset($p->usecarfilter) && $p->usecarfilter==1)?true:false;
	$startDate = isset($p->startDate)?$p->startDate:false;
	$endDate = isset($p->endDate)?$p->endDate:'';
	$vehicleIds = isset($p->vehicleK)?$p->vehicleK:'';
	$useArchived = (isset($p->usearchived) && $p->usearchived==1)?true:false;
	$location = isset($p->siteFK)?$p->siteFK:''; 
	
	if(!$useArchived && !$vehicleIds){
		$conditions[] = ' (archived = 0) ';
	}

	if($vehicleIds){
		$conditions[] = 'vehicle.vehicleK IN('.implode(',', $vehicleIds).')';
	}
	
	if($location>0){
		$conditions[] = ' (siteFK = '. $location .') ';
	}


}


//$conditions[] = ' odo.private<>1';



//if($useCarFilter){

//}





$reportSQL = "SELECT DISTINCT initial_odometer, date_obtained, vehicle.siteFK,
											vehicle.vehicleK as 'Vehicle ID', 
											manuf.name as 'Manufacturer', 
											model.modelname as 'Model', MAX(odometer) as 'maxOdometer', MIN(odometer) as 'minOdometer',
											(CASE WHEN MAX(odometer) - MIN(odometer) is not null THEN MAX(odometer) - MIN(odometer) ELSE 0 END) as 'TotalKilometres'  
									FROM 
											tblVehicle vehicle 
													INNER JOIN 
											tblModel model ON vehicle.modelFK = model.modelK 
													INNER JOIN 
											tblManufacturer manuf ON model.manufacturerFK = manuf.manufacturerK 
											 		LEFT OUTER JOIN 
											tblFuel fuel ON vehicle.vehicleK = fuel.vehicleFK AND fuel.odometer > 0 ";
if($useDateFilter){

	if($startDate){
		$reportSQL .= ' AND fuel.fuel_date>="'.date('Y-m-d h:i:s', strtotime($startDate.' 00:00:00')).'"';
	}

	if($endDate){
		$reportSQL .= ' AND fuel.fuel_date<="'.date('Y-m-d h:i:s', strtotime($endDate.' 00:00:00')).'"';
	}
}



if(count($conditions)>0){
	$reportSQL.=' WHERE ';
	for($i=0;$i<count($conditions);$i++){
		if($i>0){
			$reportSQL .= ' AND ';
		}
		$reportSQL .= $conditions[$i];
	}
}

$reportSQL .= " GROUP BY vehicle.vehicleK, manuf.name, model.modelname";

if(!$res = dbQuery($reportSQL)){
	die('SQL Error: '.dbError());
}else{
	$vehiclecosts['ID'] = 'Vehicle ID';
	$vehiclecosts['Registration'] = 'Registration Number';
	$vehiclecosts['Manufacturer'] = 'Manufacturer';
	$vehiclecosts['Model'] = 'Model';
	$vehiclecosts['Location'] = 'Location';
	$vehiclecosts['TotalKms'] = 'Total Kilometers';
	$vehiclecosts['TotalKms_ByFuel'] = 'Total Kilometers - Fuel';
	$vehiclecosts['minFuel'] = 'Fuel kms Min';
	$vehiclecosts['maxFuel'] = 'Fuel kms Max';
	$vehiclecosts['initial_odometer'] = 'Initial Odometer';

	$reportArray[] = $vehiclecosts;

	while($temp = dbFetchAssoc($res)){
		$vehiclecosts['ID'] = $temp['Vehicle ID'];
		$vehiclecosts['Registration'] = getRegoNumberByVehicleK($vehiclecosts['ID']);
		$vehiclecosts['Manufacturer'] = $temp['Manufacturer'];
		$vehiclecosts['Model'] = $temp['Model'];
		$vehiclecosts['Location'] = getLocationBysiteFK($temp['siteFK']);

		if($useDateFilter){
			if(date('Y-m-d h:i:s', strtotime($startDate.' 00:00:00'))  >  $temp['date_obtained']){
				$vehiclecosts['TotalKms'] = $temp['TotalKilometres'];
			} else {
				$vehiclecosts['TotalKms'] = $temp['maxOdometer'] - $temp['initial_odometer'];
			}
		} else {
			$vehiclecosts['TotalKms'] = $temp['maxOdometer'] - $temp['initial_odometer'];
		}

		$vehiclecosts['TotalKms_ByFuel'] = $temp['TotalKilometres'];

		$vehiclecosts['minFuel'] = $temp['minOdometer'];
		$vehiclecosts['maxFuel'] =  $temp['maxOdometer'];
		$vehiclecosts['initial_odometer'] = $temp['initial_odometer'];


		/*
		$vehiclecosts['TotalKms'] = $temp['maxOdometer'] - $temp['initial_odometer'];
		*/
		$reportArray[] = $vehiclecosts;
	}


}

$customreport = true;

function getRegoNumberByVehicleK($svehicleK) {

	$sql1="Select number from tblRego where vehicleFK =" . $svehicleK ." order by expires desc LIMIT 0, 1" ;
	$return = "";
	if(!$res = dbQuery($sql1)){
		die('SQL Error: '.dbError());
	}else{
		if(dbNumRows($res)>0){
			$item= dbFetchAssoc($res);
			$return = $item['number'];
		}
	}

	return $return;
}


function getLocationBysiteFK($siteFK) {

	$sql1="Select name from tblSite where siteK =" . $siteFK;
	$return = "";
	if(!$res = dbQuery($sql1)){
		die('SQL Error: '.dbError());
	}else{
		if(dbNumRows($res)>0){
			$item= dbFetchAssoc($res);
			$return = $item['name'];
		}
	}

	return $return;
}

?>