<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
	$reportName = 'Vehicle Utilisation';
	$reportVariables[] = '$tooltipSection = "report_utilisationbyvehicle";';
	$reportVariables[] = 'echo form_checkbox("usedatefilter", "usedatefilter", false, $label="Use Dates",$tooltipSection);';
	$reportVariables[] = 'echo form_date_select("startDate", "startDate", "", "Start Date:",$tooltipSection);';
	$reportVariables[] = 'echo form_date_select("endDate", "endDate", "", "End Date:",$tooltipSection);';
	//$reportVariables[] = 'echo form_checkbox("usecarfilter", "usecarfilter", false, $label="Use Vehicles",$tooltipSection);';
	$reportVariables[] = 'echo form_vehicle_select("vehicleK[]", "vehicleK", 0, true, 10,"Select specific vehicles to report on:<br /><br .>(* = Archived vehicle):",$tooltipSection);';
	$reportVariables[] = 'echo form_site_select("siteFK", "siteFK", "", "Location",$tooltipSection);';
	$reportVariables[] = 'echo form_checkbox("usearchived", "usearchived", false, $label="Include Archived Vehicles",$tooltipSection);';
	
	$useDateFilter = (isset($p->usedatefilter) && $p->usedatefilter==1)?true:false;
	$useCarFilter = (isset($p->usecarfilter) && $p->usecarfilter==1)?true:false;
	$startDate = isset($p->startDate)?$p->startDate:false;
	$endDate = isset($p->endDate)?$p->endDate:'';
	$vehicleIds = isset($p->vehicleK)?$p->vehicleK:'';	
	$useArchived = (isset($p->usearchived) && $p->usearchived==1)?true:false;
	$location = isset($p->siteFK)?$p->siteFK:''; 
	
	$conditions = array();
	if($useDateFilter){
		if($startDate){
			$conditions[] = ' b.booking_start>="'.date('Y-m-d h:i:s', strtotime($startDate.' 00:00:00')).'"';
			//$conditions[] = ' reg.startdate<="'.date('Y-m-d h:i:s', strtotime($startDate.' 00:00:00')).'"';
		}
		
		if($endDate){
			$conditions[] = ' b.booking_end<="'.date('Y-m-d h:i:s', strtotime($endDate.' 00:00:00')).'"';
			//$conditions[] = ' reg.expires>="'.date('Y-m-d h:i:s', strtotime($endDate.' 00:00:00')).'"';
		}

		$dateFilterDiff = workingdaysdates(strtotime($startDate.' 00:00:00'),strtotime($endDate.' 00:00:00'));
		$dateFilterDiff24 = ($dateFilterDiff * 24 * 60 * 60)/100;
		$dateFilterDiff12 = ($dateFilterDiff * 12 * 60 * 60)/100;
		
	}
	
	//if($useCarFilter){
		if($vehicleIds){
			$conditions[] = 'vehicle.vehicleK IN('.implode(',', $vehicleIds).')';
		}
	//}
	if(!$useArchived && !$vehicleIds){
		$conditions[] = ' (archived = 0) ';
	}
	
	if($location>0){
		$conditions[] = ' (vehicle.siteFK = '. $location .') ';
	}
	
	$reportSQL = "SELECT 
											vehicle.vehicleK as 'Vehicle ID', 
											reg.number as 'Registration Number', 
											tblSite.name as 'Location',
											manuf.name as 'Manufacturer', 
											model.modelname as 'Model',
											UNIX_TIMESTAMP(b.booking_end)-UNIX_TIMESTAMP(b.booking_start) as 'Time Used',";

	if($useDateFilter){
		$reportSQL .= "									(UNIX_TIMESTAMP(b.booking_end)-UNIX_TIMESTAMP(b.booking_start))/(" . $dateFilterDiff12 . ") as 'Percentage Used (12hr Day)',
											(UNIX_TIMESTAMP(b.booking_end)-UNIX_TIMESTAMP(b.booking_start))/(" . $dateFilterDiff24 . ") as 'Percentage Used (24hr Day)'";
	} else {
		$reportSQL .= "									'Not Calculated' as 'Percentage Used (12hr Day)',
											'Not Calculated' as 'Percentage Used (24hr Day)'";
	}
		
		$reportSQL .= "FROM 
											tblVehicle vehicle 
													INNER JOIN 
											tblModel model ON vehicle.modelFK = model.modelK 
													INNER JOIN 
											tblManufacturer manuf ON model.manufacturerFK = manuf.manufacturerK 
													INNER JOIN 
											tblRego reg ON vehicle.vehicleK = reg.vehicleFK INNER JOIN tblSite on siteK = vehicle.siteFK
											 		LEFT OUTER JOIN 
											tblBooking b ON vehicle.vehicleK = b.vehicleFK 
											";
											
	if(count($conditions)>0){
		$reportSQL.=' WHERE ';
		for($i=0;$i<count($conditions);$i++){
			if($i>0){
				$reportSQL .= ' AND ';
			}
			$reportSQL .= $conditions[$i];
		}
	}											
											
	$reportSQL .= " GROUP BY vehicle.vehicleK";


	function workingdays($month,$year) {
if(is_numeric($month) && is_numeric($year)) { //need to be a numbers
if($month > 12) {
return false;
}
$start = mktime(0,0,0,$month,1,$year);
$end = ($month ==12) ? mktime(0,0,0,1,1,$year+1):
mktime(0,0,0,$month+1,1,$year);
$bet = ($end - $start)/86400;
$days = 0;
for($i=0;$i<$bet;$i++) {
$newday = date("w",($start + ($i*86400))); // increment day of week
if($newday != 0 && $newday != 6) { // if not sat. or sun.
$days++; // increment days
}
}
return $days;
}
return false;
}

//echo '::' . workingdaysdates(strtotime('1-jan-2009'),strtotime('31-jan-2009'));


	function workingdaysdates($StartDate,$EndDate) {

$start = mktime(0,0,0, date('m', $StartDate), date('d', $StartDate), date('Y', $StartDate));
$end = mktime(0,0,0, date('m', $EndDate), date('d', $EndDate), date('Y', $EndDate));

$bet = ($end - $start)/86400;

$days = 0;
for($i=0;$i<$bet;$i++) {
$newday = date("w",($start + ($i*86400))); // increment day of week
//if($newday != 0 && $newday != 6) { // if not sat. or sun.
$days++; // increment days
//}
}
return $days;
}
	
?>