<?php
  /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  include_once('c_table.php');
  include_once('c_generic.php');
  include_once('form_functions.php');
  
	if(isset($p->cancel_model)){
		redirect('/?a=general/models');
	}  
  

	global $invalidFields;  
  
  $model = new cGeneric('tblModel', 'modelK');
  if(arg(2)) {
    $model->loadById(arg(2));
  }
  
  if(isset($p->op) && $p->op == 'save_model') {
    if(isset($p->delete_model)) {
    		$auditType=3;
			$auditRowId = $p->modelK;
			$audit = new c_Audit('tblModel','modelK', $user->userK, $auditType);					
			$audit->loadRow($auditRowId);
			$audit->runAudit();
      if(dbDeletePosted('tblModel', 'modelK')) {
        redirect("/?a=general/models");
      } else {
        echo "Failed to delete model";
      }
    } else {
      if(validateModel()) {
			$auditType = (isset($p->modelK) && ($p->modelK > 0)?2:1);
        if($auditRowId = dbWritePosted('tblModel', 'modelK')) {
	   	   $audit = new c_Audit('tblModel','modelK', $user->userK, $auditType);
				$audit->loadRow($auditRowId);
				$audit->runAudit();
          redirect("/?a=general/models");
        }
      }
    }
  }
  
  function validateModel(){
  		global $p, $invalidFields;

		//get field lengths
		$dbFieldSizes = dbGetFieldSizes('tblModel');
  		
  		//manufacturer
  		if($p->manufacturerFK <1){
  			$invalidFields['manufacturerFK'] = 'Please select a Manufacturer';
  		}
  		//car type
		if($p->carTypeFK < 1){
			$invalidFields['carTypeFK'] = 'Please select a Car Type';
		}
  		//model name
  		if(strlen(trim($p->modelname))==0){
  			$invalidFields['modelname'] = 'Please enter a Model Name';
  		}else{
			if(strlen($p->modelname) < $dbFieldSizes['modelname']) {
			}else{
				$invalidFields['modelname']='Model Name exceeds the maximum string length of '.$dbFieldSizes['address_one'];
			}
		}
  		
  		//ensure a combination of the supplied variables doesn't already exist
  		if(!is_array($invalidFields) || (is_array($invalidFields) && count($invalidFields)==0)){
  			$sql = 'SELECT count(*) as lcount FROM tblModel WHERE modelname="'.$p->modelname.'" AND manufacturerFK='.$p->manufacturerFK.' AND carTypeFK='.$p->carTypeFK;
  			if(arg(2)){
  				$sql.=' AND modelK !='.arg(2);
  			}
  			$res = dbQuery($sql);
       	if(!$res) {
         	debug(dbError($sql));
        	} else {
        		if(!$lCount = dbFetchAssoc($res)){
        			debug(dbError($sql));
        		}else{
        			if($lCount['lcount']>0){
        				$invalidFields[''] = 'The Model Supplied Already exists';
        			}
        			dbFreeResult($res);
				}
  			}
  		}
  		
  		if(is_array($invalidFields) && count($invalidFields)>0){
			return false;
		}else{
			return true;
		}
  }
?>

<div class='pageSubTitle'>
  Vehicle Model Administration
</div>

<table cellpadding='10' cellspacing='0' border='0' width='100%'><tr>
<td valign='top' width='50%'>

<?php
  $sql  = 'select model.* ';
  $sql .= '      ,u.username ';
  $sql .= '      ,concat(m.name, " ", model.modelname, " ", ct.typename) as model_name_long ';
  $sql .= 'from tblModel model ';
  $sql .= 'inner join tblManufacturer m on (m.manufacturerK = model.manufacturerFK) ';
  $sql .= 'inner join tblCarType ct on (ct.carTypeK = model.carTypeFK) ';
  $sql .= 'left outer join tblUser u on (u.userK = model.modified_by) ';
  $res = dbQuery($sql);
  if(!$res) {
    debug(dbError($sql));
  } else {
    $columns = array(
      array('Model', 'model_name_long'),
      array('Last Modified', 'modified_date'),
      array('Modified By', 'username'),
      array('&nbsp','history')
    );
    $tbl = new cTable($columns);
    echo "<b>Models</b><br/>";
    $tbl->drawHeader();
    while($row = dbFetchAssoc($res)) {
      $row['modified_date'] = format_date($row['modified_date']);
      $row['history'] = '<a href="showhistory.php?tableName=tblModel&tableKeyName=modelK&id='.$row['modelK'].'" target="_blank">History</a>';
      $tbl->drawRow($row, '?a=general/models/'.$row['modelK']);
    }
    $tbl->drawFooter();
  }
?>
</td>
<td valign='top'>
<? if(arg(2)) { ?>
  <b>Edit Model</b><br/>
<? } else { ?>
  <b>New Model</b>
<? } ?>
<?
  global $invalidFields;
  if(is_array($invalidFields) && count($invalidFields) > 0) {
    echo "<br/><br/>Failed to save model details, please correct the following:<br/>";
    echo "<ul>";
    foreach($invalidFields as $k=>$v) {
      if(strlen($v) > 0) {
        echo "<li>".$v."</li>";
      }
    }
    echo "</ul><br/>";
  }
?>
<? $tooltipSection = 'general_models';  ?>
  <?= form_start('model_edit', '/?a=general/models/'.arg(2), 'post'); ?>
    <?= form_hidden('op', 'save_model'); ?>
    <?= form_hidden('modelK', (strlen(trim(arg(2)))!=0?(htmlentities($model->get('modelK'))):(htmlentities(isset($p->modelK)?$p->modelK:'')))); ?>
    <?= form_hidden('modified_date', ts()); ?>
    <?= form_hidden('modified_by', sess_get('userK')); ?>
    <?= form_manufacturer_select('manufacturerFK', 'manufacturerFK', (strlen(trim(arg(2)))!=0?(htmlentities($model->get('manufacturerFK'))):(htmlentities(isset($p->manufacturerFK)?$p->manufacturerFK:''))), "Manufacturer",$tooltipSection, true); ?>
    <?= form_cartype_select('carTypeFK', 'carTypeFK', (strlen(trim(arg(2)))!=0?(htmlentities($model->get('carTypeFK'))):(htmlentities(isset($p->carTypeFK)?$p->carTypeFK:''))), 'Type',$tooltipSection, true); ?>
    <?= form_textinput('modelname', 'modelname', (strlen(trim(arg(2)))!=0?(htmlentities($model->get('modelname'))):(htmlentities(isset($p->modelname)?stripslashes($p->modelname):''))), "Model", 180, 45,$tooltipSection, true);  ?>
    <br/>
    <?php
      $buttons = array();
      $buttons[] = form_submit('submit_model', ' Submit ');
      if(count($invalidFields)>0 || arg(2)){
      	$buttons[] = form_submit('cancel_model', ' Reset ');
      }else{
      	$buttons[] = form_reset('reset_model', ' Reset ');
      }
	  if(defined('GENERAL_DELETE') && GENERAL_DELETE == True) {
		  if(arg(2)) {
      $buttons[] = form_submit('delete_model', ' Delete ', 'color:#a00;');
		  }
	  }
      echo form_button_bar($buttons);
    ?>
  <?= form_end(); ?>
</td>
</tr></table>
